
whenever sqlerror exit sql.sqlcode ;

create or replace procedure GRHUM.INIT_RECH_1_1_0_DML_AJOUT_BETA is
ass_id_doc integer;
tas_id_pere integer;
nb integer;
nb_ass_doct integer;
nb_assres_doct integer;

begin 
  select tas_id into tas_id_pere from grhum.type_association where  tas_code = 'ROLE';
  
  select count(*) into nb_ass_doct from grhum.association where ass_code = 'DOCT';
  if (nb_ass_doct = 1) 
  then 
    select ass_id into ass_id_doc from grhum.association where ass_code = 'DOCT';
    select count(*) into nb_assres_doct
    from GRHUM.ASSOCIATION_RESEAU ar,GRHUM.ASSOCIATION A1 
    where ar.ass_id_fils = ass_id_doc
    and ar.ass_id_pere = A1.ass_id
    and a1.ass_code = 'FONCTION';
    
    if (nb_assres_doct = 0)
    then 
      INSERT INTO GRHUM.ASSOCIATION_RESEAU
      SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
      FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
      WHERE A1.ASS_LIBELLE='FONCTION'
      AND A2.ASS_CODE='DOCT';
    end if;
  else 
    select GRHUM.ASSOCIATION_SEQ.NEXTVAL into ass_id_doc from dual;
    --On construit un nouveau réseau d'associations pour la gestion des doctorants :
    INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
    VALUES (ass_id_doc,'DOCTORANT',SYSDATE,SYSDATE,tas_id_pere,NULL,'DOCT');

    INSERT INTO GRHUM.ASSOCIATION_RESEAU
    SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
    FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
    WHERE A1.ASS_LIBELLE='FONCTION'
    AND A2.ASS_CODE='DOCT';
  end if;
  
  
  
  -- Pour la cotutelle
  -- un sous-réseau d'associations appelé COTUTELLE pour les cotutelles.
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'ETABLISSEMENT DE COTUTELLE',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_COT_ETAB');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_COT_ETAB';   
  
  
  -- Pour les directeurs de thèse
  -- un sous-réseau direction de thèse DIRECTION :
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'DIRECTION THESE',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_DIR');
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Directeur de thèse',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_DIR_THESE');
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Co-encadrant de thèse',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_DIR_COENC');
  
  
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_DIR';
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_DIR'
  AND A2.ASS_CODE='D_DIR_THESE';
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_DIR'
  AND A2.ASS_CODE='D_DIR_COENC';
    
  -- Pour le rattachements du doctorant au labo pour la thèse
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Laboratoire de thèse',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_LAB_THESE');
  
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_LAB_THESE';
  
  -- Pour le partenaire ECOLE DOCTORALE de rattachement 
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Ecole Doctorale de rattachement',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_ED_R');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_ED_R';
  
  
  
  -- Un sous réseau pour les différents roles liés au jury
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'JURY - SOUTENANCE',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_JURY');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_JURY';
  
  -- Un sous réseau pour les types de membres de jury
  -- Pour typer les membres du jury de thèse en président, rapporteur etc.
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'TYPE MEMBRES JURY',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_TYPE_JURY');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_JURY'
  AND A2.ASS_CODE='D_TYPE_JURY';
  
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Président',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_JR_PRES');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_TYPE_JURY'
  AND A2.ASS_CODE='D_JR_PRES';
  

  --
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Membre',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_JR_MEM');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_TYPE_JURY'
  AND A2.ASS_CODE='D_JR_MEM';
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Invité',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_JR_INV');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_TYPE_JURY'
  AND A2.ASS_CODE='D_JR_INV';
  
  -- une association pour définir les rapporteurs qui ne sont pas forcément membres du jury.
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Rapporteur',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_JURY_RAP');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_JURY'
  AND A2.ASS_CODE='D_JURY_RAP';
  
  -- un role d'employeur pour les financements de these
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Employeur',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_EMPLOYEUR');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_EMPLOYEUR';
  
  -- un role de financeur pour les financements de these
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Financeur',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_FINANCEUR');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_FINANCEUR';

  	-- Création d'un type contrat pour les thèses.
	Insert into accords.type_contrat tc (tycon_id, tycon_id_pere, tycon_id_interne, tycon_libelle, tycon_nature, tycon_niveau, tycon_recherche)
	values (accords.type_contrat_seq.nextval,10,'CONV_THESE','Convention de thèse','TYPE',2,'O');




end;
/

EXECUTE GRHUM.INIT_RECH_1_1_0_DML_AJOUT_BETA();
/

commit;

DROP PROCEDURE GRHUM.INIT_RECH_1_1_0_DML_AJOUT_BETA;
/
